// rustc alignment-padding.rs && ./alignment-padding
use std::mem;

#[derive(Debug)]
//#[repr(C)]
struct Stuff {
    a: u32,
    b: u8,
    c: u32,
    d: u8,
}

fn main() {
    let s = Stuff { a: 0x12345678, b: 0xff, c: 0x01010101, d: 0x44 };
    let p = &s as *const _ as *const u8;
    for i in 0..(mem::size_of::<Stuff>() as isize) {
        println!("*p.offset({}) == 0x{:02x}",
                 i, unsafe {*p.offset(i)});
    }
}
